// AlertServerProcess.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"
#include <winsock2.h>
#include <atlfile.h>
#include "AppCommon.h"

DWORD dwLastError;
BOOL fAutoEnd = TRUE;
int iTick = 100;
u_short sPort = htons(11111);

int receiveSock(SOCKET *sock)
{
	char buff[FILE_BUFFER_SIZE];
	memset(buff, 0, sizeof(buff));
	int rcv = recv(*sock, buff, sizeof(buff), 0);
	if(rcv < 1)
	{
		if(WSAGetLastError() == WSAEWOULDBLOCK){
			// f[^擾҂
			return ERR_WAIT_RECEIVE;
		}
		return ERR_RECEIVE;
	}
	printf(buff);

	CAtlFile af;
	HRESULT hr;
	hr = af.Create(RESULT_LOG_FNAME, GENERIC_WRITE, FILE_SHARE_WRITE, CREATE_ALWAYS);
	if(FAILED(hr))
	{
		return ERR_FILE_CREATE;
	}

	hr = af.Write(buff, sizeof(buff));
	if(FAILED(hr))
	{
		return ERR_FILE_SAVE;
	}

	hr = af.SetSize(strlen(buff));
	if(FAILED(hr))
	{
		return -555;
	}

	hr = af.Flush();
	if(FAILED(hr))
	{
		return ERR_FILE_FLUSH;
	}

	af.Close();
	return ERR_SUCCESS;
}

void optParse(_TCHAR *argv)
{
	if(_tcsncmp(argv, _T("/P"), 2) == 0)
	{
		argv += 2; // 񕶎ڈȍ~(lĂ鍀)p[X
		u_short port = htons(_ttoi(argv));
		if(port != 0)
		{
			sPort = port;
		}
	}

	if(_tcsncmp(argv, _T("/T"), 2) == 0)
	{
		argv += 2; // 񕶎ڈȍ~(lĂ鍀)p[X
		int tick = _ttoi(argv);
		if((0 < tick) && (tick <= 3600))
		{
			iTick = tick;
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	// R}hCIvV̉
	for(int i = 1; i < argc; i++)
	{
		optParse(argv[i]);
	}

	// winsock2
	WSADATA wsaData;
	int err = WSAStartup(MAKEWORD(2, 0), &wsaData);
	if(err != 0)
	{
		dwLastError = err;
		return ERR_WSASTARTUP;
	}

	// T[o\Pbg쐬
	SOCKET sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET)
	{
		return ERR_INVALID_SOCKET;
	}

	// T[o\PbgɃ|[gȂǂݒ
	struct sockaddr_in addr;
	struct sockaddr_in client;

	addr.sin_family = AF_INET;
	addr.sin_port = sPort;
	addr.sin_addr.S_un.S_addr = INADDR_ANY;

	if(bind(sock, (struct sockaddr *) &addr, sizeof(addr)) != 0)
	{
		return ERR_BIND;
	}

	// T[oNJn
	if(listen(sock, 5) != 0)
	{
		return ERR_LISTEN;
	}

	// \PbgCxg̍쐬
	HANDLE hSocketEvent = WSACreateEvent();
	WSANETWORKEVENTS events;
	WSAEventSelect(sock, hSocketEvent, FD_CLOSE | FD_ACCEPT);
	SOCKET csock = 0;

	for(;;)
	{
		// Cxgt
		DWORD dwRet = WSAWaitForMultipleEvents(1, &hSocketEvent, FALSE, 0, FALSE);
		if(dwRet == WSA_WAIT_FAILED)
		{
			break;
		}
		
		if(WSAEnumNetworkEvents(sock, hSocketEvent, &events) == SOCKET_ERROR)
		{
			break;
		}

		if(events.lNetworkEvents & FD_CLOSE)
		{
			closesocket(csock);
		}

		if(events.lNetworkEvents & FD_ACCEPT)
		{
			int len = sizeof(client);
			csock = accept(sock, (sockaddr *) &client, &len);
			int rcv = receiveSock(&csock);
			if(rcv < 0)
			{
				// G[
				printf("receiveSocket err [%d]", rcv);
				break;
			}
			closesocket(csock);
		}

		// NCAgAv݂ȂΏI
		HWND hWindow = FindWindow(NULL, _T("AlertTest "));
		if(hWindow == NULL)
		{
			if(csock != 0)
			{
				closesocket(csock);
			}
			printf("client not exists. shutting...");
			break;
		}
			
		Sleep(iTick);

	}

	// n
	WSACleanup();
	return ERR_SUCCESS;
}






